//************************************************************************
// Program Name	: Basic Functions that read  and print Various Types of Data
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Basic Functions that read  and print Various Types of Data
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|						|
//				|-----------------------|<-- fp(x29) + 28
//	  			|						|
//				|-----------------------|<-- fp(x29) + 24
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|	 *** x30 = lr'	***	|
//				|-----------------------|
//	  			|	*** x30 = lr'	***	|
//				|-----------------------|<-- fp(x29) + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp(x29)
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************
// Run Example:
// gcc Lab6_Exercise1.s
// ./a.out
// Please give an Integer (32bit) Value : 12345678900
// -539222988
// Please give a Long Long Integer (64bit) Value: 12345678900
//12345678900
//************************************************************************ 
    .data
in_message_str_1: 	.string	"Please give an Integer (32bit) Value : "
scanf_str_1: 		.string	"%d"
out_message_str_1: 	.string	"%d\n"
in_message_str_2: 	.string	"Please give a Long Long Integer (64bit) Value: "
scanf_str_2: 		.string	"%lld"
out_message_str_2: 		.string	"%lld\n"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32)
								//  and then store double x29 and x30 which is the Link Register (S.O.S). 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer
	
	bl scanf_int
	bl printf_int
	
	bl scanf_lld
	bl printf_lld
	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function

	
//************************************************************************
//**************************************************************************
scanf_int:
	stp	X29, X30, [sp, -32]!	
	add	x29, sp, 0				

	adr 	x0, in_message_str_1
	bl 		printf
	
	add		x1, x29, 28
	adr		x0, scanf_str_1
	bl		scanf
	ldr		w0, [x29, 28]
	
	ldp	x29, x30, [sp], 32
	ret
//**************************************************************************************
printf_int:
	stp		X29, X30, [sp, -16]!	
	add			x29, sp, 0				

	mov  	w1, w0
	adr 	x0, out_message_str_1
	bl 		printf

	ldp		x29, x30, [sp], 16
	ret
//**************************************************************************************
scanf_lld:
	stp	X29, X30, [sp, -32]!	
	add	x29, sp, 0				

	adr 	x0, in_message_str_2
	bl 		printf
	
	add		x1, x29, 24
	adr		x0, scanf_str_2
	bl		scanf
	ldr		x0, [x29, 24]
	
	ldp	x29, x30, [sp], 32
	ret
//**************************************************************************************
printf_lld:
	stp		X29, X30, [sp, -16]!	
	add		x29, sp, 0				

	mov  	x1, x0
	adr 	x0, out_message_str_2
	bl 		printf

	ldp		x29, x30, [sp], 16
	ret
//**************************************************************************
